;TODO:
; + Abbiegen bevorzugen
; + korrektes X-Move
; + CheckRight/-Left bzw. -Up/-Down optimieren (mergen)
; o Tank AI
;   + find way through labyrinth
;   x evade other tanks (TODO: schmalerer Bereich)
;   o attack player (TODO: improve randomness)
; x player shot aligned to grid
; - better missiles
; o kill helicopter
; ? copy graphics instead of PF into RAM
; - sounds
; - ...


    processor 6502
    include vcs.h

;===============================================================================
; A S S E M B L E R - S W I T C H E S
;===============================================================================

DISABLE     = 0
DEBUG       = 1
STACKCHECK  = 0


;===============================================================================
; C O N S T A N T S
;===============================================================================

NUM_MAZES   = 2
NUM_XBLOCKS = 9
NUM_YBLOCKS = 7
NUM_BLOCKS  = 13
NUM_TANKS   = 4

H_VERT      = 20/2
H_HORZ      =  6/2
H_TOTAL     = H_VERT+H_HORZ

H_GRID      = 13

MAXDIR      = 16
DIR_UP      =  0
DIR_RIGHT   =  4
DIR_DOWN    =  8
DIR_LEFT    = 12
DIR_HORZ    = DIR_RIGHT
DIR_HIGH    = DIR_DOWN


ENABLE_TURN = $80
NEG_TURN    = $40|ENABLE_TURN
POS_TURN    = $00|ENABLE_TURN
NO_TANK     = $20
U_TURN      = $10
TURN_FLAGS  = NEG_TURN|U_TURN

H_PLAYER    =  7
H_TANK      =  7
H_MISSILE   =  1
H_SHOT      =  2
H_SCORE     =  5

ID_P0       =  0
ID_P1       =  1
ID_HELI     =  2
ID_MISL     =  3
ID_SHOT     =  4
ID_TANK2    =  5
ID_TANK3    =  6
ID_TANK0    =  7
ID_TANK1    =  8
ID_TANKLST  =  5

X0          = 14
Y0          = 10

Y_TANK0     = Y0    ; green
Y_TANK1     = Y0    ; orange
Y_TANK2     = Y0    ; blue
Y_TANK3     = Y0    ; red

X_TANK0     = X0+24+2
X_TANK1     = X0
X_TANK2     = X0+48
X_TANK3     = X0+69+3

X_PLAYER    = X0+124
Y_PLAYER    = Y0+78
X_GRID      = NUM_XBLOCKS*2-2
Y_GRID      = NUM_YBLOCKS*2-2

opBIT_B     = $24
opBIT_W     = $2c

opNOP_B     = $82
opNOP_W     = $0c

ENABLE      = %10
REFLECT     = %1000


;===============================================================================
; Z P - V A R I A B L E S
;===============================================================================

    SEG.U   variables
    ORG     $80

frameCnt    .byte
random      .byte
maze        .byte

PF0Lst      ds NUM_BLOCKS
PF1Lst      ds NUM_BLOCKS
PF2Lst      ds NUM_BLOCKS

tmpVar      .word
tmpVar2     = tmpVar+1
tmpVar3     .byte
tmpVar4     .byte
jmpPtr      .word

ptrP0       .word
ptrP1       .word
ptrBLSize   .word
ptrBLMove   .word

score       .word
lives       .byte
tmp0        .byte
tmp1        .byte
tmp2        .byte
tmp3        .byte
;---------------------------------------
xPosLst     ds 5+4
xPosP0      = xPosLst+0
xPosP1      = xPosLst+1
xPosPlayer  = xPosLst+2
xPosMisl    = xPosLst+3
xPosShot    = xPosLst+4

xPosTankLst = xPosLst+5
xPosTank0   = xPosTankLst+0
xPosTank1   = xPosTankLst+1
xPosTank2   = xPosTankLst+2
xPosTank3   = xPosTankLst+3
;---------------------------------------
yPosLst     ds 5+4
yPosP0      = yPosLst+0
yPosP1      = yPosLst+1
yPosPlayer  = yPosLst+2
yPosMisl    = yPosLst+3
yPosShot    = yPosLst+4

yPosTankLst = yPosLst+5
yPosTank0   = yPosTankLst+0
yPosTank1   = yPosTankLst+1
yPosTank2   = yPosTankLst+2
yPosTank3   = yPosTankLst+3
;---------------------------------------
dirPlayer   ds 3+4
dirLst      = dirPlayer-2
dirMisl     = dirLst+3
dirShot     = dirLst+4

dirTankLst  = dirLst+5
;---------------------------------------

xGrid       .byte
yGrid       .byte       ;
xyMove      .byte
xyDir       .byte       ; y-000vvv

hMisl       .byte
killCnt     .byte
yPosHeli    .byte

  IF STACKCHECK
stackError  .byte
  ENDIF


;===============================================================================
; M A C R O S
;===============================================================================

  MAC BIT_B
    .byte   opBIT_B
  ENDM

  MAC BIT_W
    .byte   opBIT_W
  ENDM

  MAC NOP_B
    .byte   opNOP_B
  ENDM

  MAC NOP_W
    .byte   opNOP_W
  ENDM

  MAC DEBUG_BRK
    IF DEBUG
      brk                         ;
    ENDIF
  ENDM

  MAC SLEEP
    IF {1} = 1
      ECHO "ERROR: SLEEP 1 not allowed !"
      END
    ENDIF
    IF {1} & 1
      nop $00
      REPEAT ({1}-3)/2
        nop
      REPEND
    ELSE
      REPEAT ({1})/2
        nop
      REPEND
    ENDIF
  ENDM


;===============================================================================
; R O M - C O D E
;===============================================================================

    SEG     Bank0
    ORG     $f000, $ff

Kernel SUBROUTINE

DrawScreen:
.waitTim:
    lda     INTIM
    bne     .waitTim
    sta     WSYNC
;---------------------------------------------------------------
    sta     VBLANK

    ldy     #7*H_VERT + 6*H_HORZ+1

    jsr     DrawBorder          ;           @08
    ldx     #NUM_BLOCKS-1       ; 2
    BIT_B                       ; 1
.skipDrawPlayer:                ;           @11
    nop                         ; 2
    lsr                         ; 2
    sta     ENAM0               ; 3
    bcs     .contDrawPlayer     ; 3 = 10

.loopBlock:                     ;           @51
    sec                         ; 2
    nop                         ; 2
.nextBlock:                     ;           @55
    lda     PF2Lst,x            ; 4
    sta     PF2                 ; 3         @62     >=59
    lda     PF1Lst,x            ; 4
    sta     PF1                 ; 3         @69     >=69
    lda     PF0Lst,x            ; 4
    sta     PF0                 ; 3 = 21    @76     >=76
;---------------------------------------
    tya                         ; 2                 draw tank missile
    sbc     yPosMisl            ; 3
    adc     hMisl               ; 3
    lda     #ENABLE             ; 2
    sbc     #0                  ; 2
    sta     ENAM1               ; 3 = 15    @15

    tya                         ; 2                 draw player shot
    sbc     yPosShot            ; 3
    adc     #H_SHOT             ; 2
    lda     #ENABLE             ; 2
    sbc     #0                  ; 2
    sta     ENABL               ; 3 = 14    @29     (VDELed!)

    tya                         ; 2                 draw 2nd tank (part 1/2)
    sbc     yPosP1              ; 3
    adc     #H_TANK             ; 2
    lda     #0                  ; 2
    bcc     .skipDrawP1         ; 2
    lda     (ptrP1),y           ; 5
.skipDrawP1:
    sec                         ; 2
    pha                         ; 3 = 17/21 @50

    tya                         ; 2                 draw helicopter (part 1/2)
    sbc     yPosHeli            ; 3
    adc     #H_PLAYER           ; 2
    bcc     .skipDrawPlayerA    ; 2
    lda     (ptrBLMove),y       ; 5
    sta     HMM0                ; 3         @67
.skipDrawPlayerA:               ;   = 10/17

    pla                         ; 4                 draw 2nd tank (part 2/2)
    sta     WSYNC               ; 3 =  7    @74
;---------------------------------------
    sta     HMOVE               ; 3
    sta     GRP1                ; 3 =  6    @06

    lda     #ENABLE|1           ; 2                 draw helicopter (part 2/2)
    bcc     .skipDrawPlayer     ; 2
    sta     ENAM0               ; 3 =  7    @13
    lda     (ptrBLSize),y       ; 5
    sta     NUSIZ0              ; 3 =  8    @21
.contDrawPlayer:                ;

    dey                         ; 2
    tya                         ; 2                 draw 1st tank
    sbc     yPosP0              ; 3
    adc     #H_TANK             ; 2
    bcs     .doDrawP0           ; 2
    lda     #0                  ; 2
    NOP_W                       ;-1
.doDrawP0:
    lda     (ptrP0),y           ; 5
    sta.w   GRP0                ; 4 = 21/21 @42     (VDELed!)

    tya                         ; 2
    cmp     BlockSizeTbl,x      ; 4                 current PF block finished?
    bne     .loopBlock          ; 2=  8/ 9
    dex                         ; 2
    bpl     .nextBlock          ; 2=  4/ 5 @55

    sta     WSYNC
;---------------------------------------
    jsr     DrawBorder
    sta     WSYNC

    stx     PF0
    stx     PF1
    stx     PF2
    stx     ENAM1               ;       disable tank missile
    stx     ENABL               ;       disable player shot (BL)
    stx     GRP1                ;       copy delayed BL

;*** and now, the (very preliminary) score: ***
    ldy     #%10
    sty     CTRLPF

    lda     score
    and     #$0f
    tax
    lda     DigitPtrTbl,x
    sta     tmp0
    lda     score
    lsr
    lsr
    lsr
    lsr
    tax
    lda     DigitPtrTbl,x
    sta     tmp1

    lda     lives
    and     #$0f
    tax
    lda     DigitPtrTbl,x
    sta     tmp3


    lda     #$48
    sta     COLUP0
    lda     #$8a
    sta     COLUP1
    ldx     #H_SCORE
.loopScore:
    sta     WSYNC
    ldy     tmp3
    dec     tmp3
    lda     DigitTbl,y
    and     #$0f
    sta     PF1
;    lda     #0
;    sta     PF2

;    lda     #0
;    sta     PF1
    ldy     tmp0
    dec     tmp0
    lda     DigitTbl,y
    and     #$0f
    sta     tmp2

    ldy     tmp1
    dec     tmp1
    lda     DigitTbl,y
    and     #$f0
    ora     tmp2
    sta     PF1

    dex
    bne     .loopScore

    lda     #2
    sta     WSYNC
;---------------------------------------------------------------
    sta     VBLANK
    rts


DrawBorder SUBROUTINE
    lda     #$ff
    sta     PF1
    sta     PF2
    lda     #$c3                ;           lover bits uses for ENAM0
    sta     PF0

    ldx     #H_HORZ*2-1
.loop:
    dex
    sta     WSYNC
    bne     .loop               ; 2
    rts                         ; 6


Start SUBROUTINE
    sei                         ;           Disable interrupts, if there are any.
    cld                         ;           Clear BCD math bit.
    ldx     #0
    txs
    pha                         ;           Set stack to beginning.
    txa
.clearLoop:
    pha
    dex
    bne     .clearLoop

    jsr     GameInit

.mainLoop:
    jsr     VerticalBlank
;    jsr     GameCalc
  IF STACKCHECK
    lda     #$a5
    cmp     stackError
    beq     .noStackError
    lda     #$44
    sta     COLUBK
.noStackError:
  ENDIF

    jsr     DrawScreen
    jsr     OverScan
    jmp     .mainLoop


GameInit SUBROUTINE
  IF STACKCHECK
    lda     #$a5
    sta     stackError
  ENDIF
    inc     random

  IF DEBUG
;    lda     #$74
;    sta     score
;    lda     #$43
;    sta     score+1
  ENDIF
    lda     #$03
    sta     lives

InitMaze SUBROUTINE
.ptrPF      = ptrP0
.ptrPtrPF   = ptrP1

;set PF color:
    ldy     maze
    lda     PFMazeColTbl,y
    sta     COLUPF

;copy PF graphics into RAM:
    lda     #>PFTbl
    sta     .ptrPF+1
    sta     .ptrPtrPF+1

    tya
    asl
    adc     maze
    adc     #<PFPtrTbl
    sta     .ptrPtrPF

    ldx     #NUM_BLOCKS*3-1
    ldy     #2
.loopPFReg:
    sty     tmpVar
    lda     (.ptrPtrPF),y
    sta     .ptrPF
    ldy     #NUM_BLOCKS-1
.loopPF:
    lda     (.ptrPF),y
    sta     PF0Lst,x
    dex
    dey
    bpl     .loopPF
    ldy     tmpVar
    dey
    bpl     .loopPFReg
;reuse y to enable vertical delay:
    sty     VDELP0
    sty     VDELBL
;TODO: reenable all tanks

InitLife SUBROUTINE
    lda     #X_PLAYER
    sta     xPosPlayer
    lda     #Y_PLAYER
    sta     yPosPlayer
    lda     #X_GRID
    sta     xGrid
    lda     #Y_GRID
    sta     yGrid

    ldx     #NUM_TANKS-1
.loopPos:
    lda     dirTankLst,x
    and     #NO_TANK            ;       tank killed?
    bne     .skipRepos          ;        yes, do not reset tank
    lda     TankXPos,x
    sta     xPosTankLst,x
    lda     TankYPos,x
    sta     yPosTankLst,x
    lda     TankDir,x
    sta     dirTankLst,x
.skipRepos:
    dex
    bpl     .loopPos
;    rts                         ;       save one byte

GetFrameXY SUBROUTINE
    lda     #1
    tax
    tay
    bit     frameCnt
    beq     .set01
    ldy     #3
.set01:
    rts
;GetFrameXY END


CheckMoveObject SUBROUTINE
    lda     yPosLst,x
    beq     .skipObject
MoveObject:
    ldy     dirLst,x
MoveObjectDir:
    lda     xPosLst,x
    clc
    adc     XDirTbl,y
    sta     xPosLst,x
    lda     yPosLst,x
    clc
    adc     YDirTbl,y
    sta     yPosLst,x
.skipObject:
    rts
;CheckMoveObject END


VerticalBlank SUBROUTINE
    lda     #2
    sta     WSYNC
    sta     VSYNC

;*******************************************
    lda     SWCHB
    lsr
    bcs     .skipReset
    brk
.skipReset:
    lsr
    bcs     .skipSelect
    lda     frameCnt
    and     #$1f
    bne     .skipSelect
    lda     maze
    eor     #$01
    sta     maze
    jsr     InitMaze
.skipSelect:
    sta     WSYNC
    sta     WSYNC
    lda     #0
    ldx     #44-8
    sta     WSYNC
    sta     VSYNC
    stx     TIM64T
;    rts

GameCalc SUBROUTINE
; move player shot and tank missile:
    ldx     #ID_SHOT
    jsr     CheckMoveObject
    jsr     CheckMoveObject
    dex                         ;           x = #ID_MISL
    jsr     CheckMoveObject

; copy values of currently displayed tanks:
    jsr     GetFrameXY          ;           x = 1, y = 1/3
.loopCopyTank:
    lda     xPosTankLst,y
    sta     xPosP0,x
    lda     yPosTankLst,y
    sta     yPosP0,x
    lda     dirTankLst,y
    and     #~TURN_FLAGS        ;           clear turning flags
    sta     tmpVar,x
    lda     TankColTbl,y
    sta     COLUP0,x
    dey
    dex
    bpl     .loopCopyTank

; set low pattern pointers for both displayed tanks:
    ldx     #1
.loopSet:
    ldy     #MAXDIR/2+1
    lda     tmpVar,x            ;           tank direction
    cmp     #NO_TANK            ;           tank destroyed?
    clc
    beq     .contCircle

    cmp     #MAXDIR/2+1
    bcc     .okDir
    eor     #$ff
    adc     #MAXDIR
    dec     xPosP0,x            ;           adjust x position
.okDir:
    tay
.contCircle:
    lda     #REFLECT-1
    adc     #0
    sta     REFP0,x

    lda     frameCnt
    and     #2
    beq     .PatternA
    lda     #H_TANK
.PatternA:
    adc     #<TankPatTbl+H_TANK
    sbc     yPosP0,x
    adc     Mul14Tbl,y
    sta     ptrP0+1,x
    dex
    bpl     .loopSet
    sta     ptrP0               ;           the last ptr was set wrong!

; set high pattern pointers for tanks and helicopter:
    ldx     #>Tank0a
    stx     ptrP0+1
    stx     ptrP1+1
    dex
    stx     ptrBLSize+1
    stx     ptrBLMove+1

; x-position all five objects:
    ldx     #RESBL-RESP0
.loopXPos:
    lda     xPosLst,x
    jsr     SetPosX
    dex
    bpl     .loopXPos
    sta     WSYNC
    sta     HMOVE

; set low pattern pointers for helicopter:
    lda     dirPlayer
    lsr
    lda     frameCnt
    and     #%10
    beq     .skipB
    lda     #PlayerMoveLeftB-PlayerMoveLeftA
.skipB
    bcc     .dirLeft
    adc     #<PlayerMoveRightA-PlayerMoveLeftA-1
.dirLeft:
    adc     #<PlayerMoveLeftA+H_PLAYER+1
    sbc     yPosPlayer
    sta     ptrBLMove

    lda     #<PlayerSizeTbl+H_PLAYER
;    sec
    sbc     yPosPlayer
    sta     ptrBLSize

; let killed helicopter blink:
    ldx     yPosPlayer
    lda     killCnt
    beq     .skipKill
    lda     frameCnt
    and     #%1000
    bne     .skipKill
    dec     killCnt
    bne     .contKill
    jsr     InitLife
.contKill:
    ldx     #0                      ;       disable helicopter
.skipKill:
    stx     yPosHeli

; set ball size and enable reflected PF:
    lda     #%010001
    sta     CTRLPF

; clear all move reigsters:
    sta     HMCLR
;    jsr     NextRandom
;    rts
;GameCalc END;


NextRandom SUBROUTINE
    lda    random           ; 3
    asl                     ; 2
    eor    random           ; 3
    asl                     ; 2
    eor    random           ; 3
    asl                     ; 2
    asl                     ; 2
    eor    random           ; 3
    asl                     ; 2
    rol    random           ; 5
    rts
;NextRandom END


CheckJSR  SUBROUTINE
    jmp     (jmpPtr)


TankAI SUBROUTINE
.tankIdx    = tmpVar

;***** missile AI: *****
; check if missile active:
    lda     yPosMisl
    bne     .skipMisl

; get tank orientation:
    lda     dirTankLst,x
    lsr
    lsr
    tay
    and     #DIR_HORZ/4
    beq     .vertDirTank

; check if helicopter is in vertical range:
    lda     yPosPlayer
;    sec
    sbc     yPosTankLst,x
    adc     #4+1
    cmp     #9
    bcs     .skipMisl

; check if helicopter is in horzizontal range:
    lda     xPosTankLst,x
    cmp     xPosPlayer
    tya
    eor     #DIR_RIGHT/4
    bpl     .contHorz
    DEBUG_BRK
; check if helicopter is in horzizontal range:
.vertDirTank:
    lda     xPosPlayer
;    sec
    sbc     xPosTankLst,x           ;       CF=0!
    adc     #4+1
    cmp     #9
    bcs     .skipMisl

; check if helicopter is in vertical range:
    lda     yPosTankLst,x
    cmp     yPosPlayer
    tya
.contHorz:
    bne     .downLeftDirTank
    bcc     .startMisl
    clc
.downLeftDirTank:
    bcc     .skipMisl

.startMisl:
; fire new missile:
    sty     dirMisl
    lda     xPosTankLst,x
    adc     MislOfsX,y
    sta     xPosMisl
    lda     yPosTankLst,x
    adc     MislOfsY,y
    sta     yPosMisl
    lda     MislHeight,y
    sta     hMisl
    lda     MislSize,y
    sta     NUSIZ1
.skipMisl:


;***** find a direction for the tank *****
.xGridTank  = tmpVar3

; check if tank is exactly at grid position:
; calc x-grid
    lda     xPosTankLst,x
    ldy     #NUM_XBLOCKS*2
.loopX:
    dey
    dey
    cmp     XGridTbl,y
    bcc     .loopX
    bne     .skipTurn
    tya
    lsr
    sta     .xGridTank

;calc y-grid
    lda     yPosTankLst,x
    ldy     #NUM_YBLOCKS*2
.loopY:
    dey
    dey
    cmp     YGridTbl,y
    bcc     .loopY
    beq     .checkDirs
.skipTurn:
    rts

; get all valid new directions:
.validDirs  = tmpVar2
.dirIdx     = tmpVar4

.checkDirs:
    ldx     #MAXDIR/4-1
.loopCheckDir:
    stx     .dirIdx
    lda     CheckJSRTbl,x
    sta     jmpPtr
    lda     CheckDirTbl,x
    ldx     .tankIdx
    cmp     dirTankLst,x
    beq     .notDir
    ldx     .xGridTank
    jsr     CheckJSR                ;       y = Y-GridTank
    bne     .notDir
    sec
    NOP_B
.notDir:
    clc
    rol     .validDirs
    ldx     .dirIdx
    dex
    bpl     .loopCheckDir

; convert distances to helicopter into index values (tricky!):
.diffX      = tmpVar4

    ldx     .tankIdx
    ldy     #5
    lda     xPosPlayer
    sec
    sbc     xPosTankLst,x
    beq     .equX
    bcs     .posX
    ldy     #0
    sbc     #0                      ;       CF=0!
    eor     #$ff
    NOP_W
.equX:
    ldy     #8
.posX:
    sta     .diffX
    lda     yPosPlayer
    sec
    sbc     yPosTankLst,x
    beq     .equY
    bcs     .posY
    sbc     #0                      ;       CF=0!
    eor     #$ff
    iny
    iny
.posY:
    iny
.equY:
    cmp     .diffX                  ;       dY > dX?
    bcc     .skipIny
    iny
    clc
.skipIny:

; select new direction based on valid and ordered directions:
.tmpDir     = tmpVar3

    lda     TurnDirTbl,y
.loopAIDir:
    sta     .tmpDir
    and     #%11
    tay
    bcc     .skipRandom
    eor     random
    and     #%11                    ;       25% randomness (except for optimal direction)
;    cmp     .tankIdx
    beq     .skipDir
.skipRandom:
    lda     BitTbl,y
    and     .validDirs
    bne     .doTurn
.skipDir:
    lda     .tmpDir
    lsr
    lsr
    sec
    bne     .loopAIDir

; make sure that there is a valid direction:
    ldy   #-1
.loopTurn:
    iny
    lsr     .validDirs
    bcc     .loopTurn

; continue with old or start turning into new direction:
.doTurn:
    tya
    ora     dirTankLst,x
    tay
    lda     NewDirTbl,y
    sta     dirTankLst,x
    rts
;TankAI END


CheckOtherTanks SUBROUTINE
; check if tank is close to other tanks
; a = y-Pos
; x = tank-index
; y = direction/4
.tankIdx    = tmpVar
.xPosTank   = tmpVar2
.yPosTank   = tmpVar3

    sta     .yPosTank
    lda     xPosTankLst,x
    sta     tmpVar2

    ldx     #NUM_TANKS-1
.loopTanks:
    cpx     .tankIdx            ;       don't check tank with itself
    beq     .nextTank

    lda     .xPosTank
    clc
    adc     XCheck1Tbl,y
    sbc     xPosTankLst,x       ;       CF=0!
    cmp     XCheck2Tbl,y
    bcs     .nextTank

    lda     .yPosTank
;    clc
    adc     YCheck1Tbl,y        ;       CF=0!
    sbc     yPosTankLst,x       ;       CF=0!
    cmp     YCheck2Tbl,y
    bcc     .startUTurn
.nextTank:
    dex
    bpl     .loopTanks
    ldx     .tankIdx
    rts

.startUTurn:
    ldx     .tankIdx
    lda     dirTankLst,x
    ora     #POS_TURN|U_TURN|1
    sta     dirTankLst,x
    rts
;CheckOtherTanks END


GetGridHigh SUBROUTINE
    lda     yGrid
    and     #~%1
    tay
    lda     xGrid
    lsr
    tax
    rts


KillTank:
; TODO: scoring
    lda     #NO_TANK
    sta     dirTankLst,y
    rts

OverScan SUBROUTINE
    lda     #36-4+10
    sta     TIM64T

;********** collisions **********
; shot collisions:
; which tanks are displayed?
    jsr     GetFrameXY

    dey
    bit     CXM1P               ;       missile vs. tank?
    bmi     .killTank
    iny
    bvc     .loopShot
.killTank:
    jsr     KillTank

.loopShot:
    lda     CXP0FB,x
    asl
    bpl     .nextShot
    lda     dirShot
    asl
    asl
    cmp     dirTankLst,y
    bne     .nextShot
    jsr     KillTank
    bne     .disableShot
    DEBUG_BRK

.nextShot:
    dey
    dex
    bpl     .loopShot

    lda     yPosShot
    cmp     ##7*H_VERT + 6*H_HORZ+1+2
    bcs     .disableShot
    bit     CXBLPF
    bpl     .skipDisableShot
.disableShot:
    lda     #0
    sta     yPosShot
.skipDisableShot:

; missile collisions:
    lda     yPosMisl
    cmp     ##7*H_VERT + 6*H_HORZ+1+2
    bcs     .disableMisl

    bit     CXM1FB                  ;       missile vs. PF?
    bpl     .skipMisl               ;
.disableMisl:
    lda     #0
    sta     yPosMisl
.skipMisl:


;*******************************************
    inc     frameCnt

    lda     killCnt
    bne     .skipJMP

    bit     CXM0P                   ;       helicopter vs. tank?
    bvs     .killPlayer
    bmi     .killPlayer

    bit     CXPPMM                  ;       helicopter vs. missile?
    bvc     .doMoves
    lda     #0
    sta     yPosMisl
.killPlayer:
    lda     #64
    sta     killCnt
    dec     lives
.skipJMP:
    jmp     .skipAllMoves


;********** move tanks **********
.tankIdx    = tmpVar
; tankDir;
; 0..1: turning step
; 2..3: direction
; 6   : negative turning direction
; 7   : turning

.doMoves:
    lda     frameCnt
    and     #$03
    bne     .skipMoveTanks

    lda     #>CheckLeft
    sta     jmpPtr+1

    ldx     #NUM_TANKS-1
.loopMove:
    stx     .tankIdx
    lda     dirTankLst,x
    tay
    and     #U_TURN|%0011       ;       tank turning?
    beq     .moveTank           ;        no, move forward

;*** turn the tank: ***
    and     #%11
    cmp     #%01

    lda     frameCnt
    and     #$07
    bne     .nextMove

    tya
    bcs     .noUTurn
    and     #~U_TURN             ;       disable turn flag
    tay
.noUTurn:
    cpy     #NEG_TURN
    bcs     .turnNeg
;    tya
    and     #%1111              ;       prevent bit-overflow
    eor     #%1111
    bne     .turnPos
    tya
    and     #POS_TURN|U_TURN
    tay
    NOP_B
.turnPos:
    iny
    NOP_B
.turnNeg:
    dey
    sty     dirTankLst,x
    bne     .nextMove
    DEBUG_BRK

.moveTank:
    tya                         ;       tank finished turning?
    bmi     .skipAI             ; 2     yes, skip AI

    cmp     #NO_TANK
    beq     .nextMove

    jsr     TankAI
    lda     dirTankLst,x        ;       tank started turning?
    bmi     .nextMove           ;        yes, don't move
.skipAI:
    and     #%1100              ;        disable turning flags
    sta     dirTankLst,x
    lsr
    lsr
    tay

    txa
    adc     #ID_TANKLST
    tax
    jsr     MoveObjectDir
    ldx     .tankIdx
;    lda     xPosTankLst,x
;    adc     XDirTbl,y           ;       CF = 0!
;    sta     xPosTankLst,x
;    lda     yPosTankLst,x
;    clc
;    adc     YDirTbl,y
;    sta     yPosTankLst,x
    jsr     CheckOtherTanks
.nextMove:
    dex
    bpl     .loopMove
.skipMoveTanks:


; set helicopter graphic direction:
    ldx     dirPlayer
    lda     SWCHA
    bmi     .skipRightDir
    ldx     #%011
.skipRightDir:
    asl
    bmi     .skipLeftDir
    ldx     #%110
.skipLeftDir:
    stx     dirPlayer
    asl
    bmi     .skipDownDir
;    lda     dirPlayer
    txa
    and     #~%110
    ora     #%100
    bne     .setDirY

.skipDownDir:
    asl
    bmi     .skipUpDir
;    lda     dirPlayer
    txa
    and     #~%110
.setDirY:
    tax
.skipUpDir
    stx     dirPlayer


    bit     INPT4
    bmi     .skipFire
    lda     yPosShot
    bne     .skipFire
    lda     dirPlayer
    lsr
    sta     dirShot
    lda     xPosPlayer
    adc     #3
    sta     xPosShot
    lda     yPosPlayer
    sbc     #2
    sta     yPosShot
.skipFire:

    lda     frameCnt
    and     #$01
    beq     .doMoveHeli
    jmp     .skipJoystick

;*****************************************************************
; move helicopter horizontal/vertical:
.doMoveHeli:
    ldx     #yPosPlayer
    ldy     yGrid
    lda     YGridTbl,y
    bit     xyDir
    bmi     .moveVert
    bvc     .skipMoveHeli
    ldx     #xPosPlayer
    ldy     xGrid
    lda     XGridTbl,y
.moveVert:
    cmp     $00,x               ;       x/yPosPlayer
    bcc     .moveNeg
    inc     $00,x               ;       x/yPosPlayer
    NOP_W
.moveNeg:
    dec     $00,x               ;       x/yPosPlayer
    eor     $00,x               ;       x/yPosPlayer
    bne     .skipMoveHeli
    sta     xyDir               ;       A = 0!
.skipMoveHeli:

;---------------------------------------
; prefer change of helicopter direction:
    inc     xyDir
    cpx     #yPosPlayer
    bne     .checkVert

.checkHorz:
    bit     xyDir
    bmi     .endHorz
    lda     yGrid
    lsr
    bcs     .endHorz

    ldx     xGrid
    ldy     XGridTbl,x
    lda     SWCHA
    bmi     .skipRight
    cpy     xPosPlayer
    beq     .contRight
    bcs     .endHorz
.contRight:
    jsr     GetGridHigh
    jsr     CheckRight
    bne     .endHorz
    inc     xGrid
    bpl     .setHorz
    DEBUG_BRK
.skipRight:

    asl
    bmi     .skipLeft
    cpy     xPosPlayer
    bcc     .endHorz
    txa
    lsr
    bcs     .skipCheckLeft
    jsr     GetGridHigh
    jsr     CheckLeft
    bne     .endHorz
.skipCheckLeft:
    dec     xGrid
.setHorz:
    lda     #$40
    bne     .setMove

.skipLeft:
.endHorz:
    dec     xyDir

;---------------------------------------
.checkVert:
    bit     xyDir
    bvs     .endVert
    lda     xGrid
    lsr
    bcs     .endVert

    ldx     yGrid
    ldy     YGridTbl,x
    lda     SWCHA
    asl
    asl
    bmi     .skipDown
    cpy     yPosPlayer
    bcc     .endVert
    txa
    lsr
    bcs     .skipCheckDown
    jsr     GetGridHigh
    jsr     CheckDown
    bne     .endVert
.skipCheckDown:
    dec     yGrid
    bpl     .setVert
    DEBUG_BRK
.skipDown:

    asl
    bmi     .skipUp
    cpy     yPosPlayer
    beq     .contUp
    bcs     .endVert
.contUp:
    jsr     GetGridHigh
    jsr     CheckUp
    bne     .endVert
    inc     yGrid
.setVert:
    lda     #$80
.setMove:
    sta     xyDir
.skipUp:
.endVert:
    lda     xyDir
    lsr
    bcc     .skipJoystick
    jmp     .checkHorz

.skipJoystick:


.skipAllMoves:
    sta     CXCLR

    jsr     GetGridHigh
    tya
    lsr
    sta     tmpVar
    txa
    asl
    asl
    asl
    asl
    ora     tmpVar
;  lda     xGrid
    sta     score


.waitTim:
    lda     INTIM
    bne     .waitTim
    rts
;OverScan END


CheckLeft SUBROUTINE
    cpx     #1
    bcc     .notFree
    dex
    jsr     GetPattern
    inx
    and     HorzMaskTbl-1,x
.notFree:
    rts

CheckRight SUBROUTINE
    cpx     #NUM_XBLOCKS-2
    bcc     .checkFree
    bne     .notFree
.checkFree:
    jsr     GetPattern
    and     HorzMaskTbl,x
.notFree:
    rts


CheckDown SUBROUTINE
    cpy     #1
    bcc     NotFreeVert
    dey
    jsr     GetPattern
    iny
    bne     ContCheckDown

CheckUp SUBROUTINE
    cpy     #NUM_YBLOCKS*2-3
    bcs     NotFreeVert
    iny
    jsr     GetPattern
    dey
ContCheckDown:
    and     VertMaskTbl,x
NotFreeVert:
    rts


GetPattern SUBROUTINE
    lda     PF1Lst,y
    cpx     #2
    bcc     .leftRight
    cpx     #6
    bcs     .leftRight
    lda     PF2Lst,y
.leftRight:
    rts


SetPosX SUBROUTINE
; calculates the values and positions objects:
; Input:
; - a = x-position
    tay                      ; 2
    iny                      ; 2
    tya                      ; 2
    and    #$0F              ; 2
    sta    tmpVar            ; 3
    tya                      ; 2
    lsr                      ; 2
    lsr                      ; 2
    lsr                      ; 2
    lsr                      ; 2
    tay                      ; 2
    clc                      ; 2
    adc    tmpVar            ; 3
    cmp    #$0F              ; 2
    bcc    .skipIny          ; 2
    sbc    #$0F              ; 2
    iny                      ; 2
.skipIny:
    sta    WSYNC             ; 3
    eor    #$07              ; 2
    asl                      ; 2
    asl                      ; 2
    asl                      ; 2
    asl                      ; 2
; Return:
; - y = coarse value for delay loop
; - a = fine value for HMxy
    sta.wx  HMP0,x
;    .byte   $9d, HMP0, $00   ; 5        @15
.waitPos:
    dey                      ; 2
    bpl    .waitPos          ; 2
.bankCheck:
    sta    RESP0,X           ; 4
    rts                      ; 6
;SetPosX END

  IF >.waitPos != >.bankCheck
    ECHO ""
    ECHO "ERROR: SetPosX: >.waitPos != >.bankCheck !"
    ECHO ""
    ERR
  ENDIF


;===============================================================================
; R O M - T A B L E S (Bank 0)
;===============================================================================
    org     $f630, $ff
PFTbl:
;PF0Tbl_1:
;    .byte   %01000000
;    .byte   %01000000
;    .byte   %01000000
;    .byte   %11000000
PF0Tbl_0:
PF0Tbl_1:
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
    .byte   %01000000
PF1Tbl_0:
    .byte   %00000000
    .byte   %00111110
    .byte   %00100000
    .byte   %00100011
    .byte   %00000010
    .byte   %00100010
    .byte   %00100000
    .byte   %00100010
    .byte   %00000010
    .byte   %00100011
    .byte   %00100000
    .byte   %00111110
    .byte   %00000000
PF2Tbl_0:
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %11000111
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %11000111
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000

PF1Tbl_1:
    .byte   %00000000
    .byte   %00111111
    .byte   %00000000
    .byte   %00100011
    .byte   %00100000
    .byte   %00111110
    .byte   %00000000
    .byte   %00111110
    .byte   %00100000
    .byte   %00100011
PF2Tbl_1:
    .byte   %00000000
    .byte   %00111111
    .byte   %00000000
;    .byte   %00000000
;    .byte   %00111111
;    .byte   %00000000
    .byte   %01000111
    .byte   %01000100
    .byte   %01000100
    .byte   %01000000
    .byte   %01000100
    .byte   %01000100
    .byte   %01000111
    .byte   %00000000
    .byte   %00111111
    .byte   %00000000


;PF1Tbl_1:
;    .byte   %00000000
;    .byte   %00111110
;    .byte   %00000000
;    .byte   %11100011
;    .byte   %00000000
;    .byte   %00100011
;    .byte   %00100000
;    .byte   %00100011
;    .byte   %00000000
;    .byte   %00100010
;    .byte   %00100010
;    .byte   %00100010
;    .byte   %00000000
;PF2Tbl_1:
;    .byte   %00000000
;    .byte   %00111100
;    .byte   %00000000
;    .byte   %11000111
;    .byte   %00000000
;    .byte   %11111111
;    .byte   %00000000
;    .byte   %11111111
;    .byte   %00000000
;    .byte   %01000100
;    .byte   %01000100
;    .byte   %01000100
;    .byte   %00000000


;PF0PtrTbl:
;    .byte   <PF0Tbl_0, <PF0Tbl_1
;PF1PtrTbl:
;    .byte   <PF1Tbl_0, <PF1Tbl_1
;PF2PtrTbl:
;    .byte   <PF2Tbl_0, <PF2Tbl_1
PFPtrTbl:
    .byte   <PF0Tbl_0, <PF1Tbl_0, <PF2Tbl_0
    .byte   <PF0Tbl_1, <PF1Tbl_1, <PF2Tbl_1
;PF2PtrTbl:
;    .byte   <PF2Tbl_0, <PF2Tbl_1
;PF1PtrTbl:
;    .byte   <PF1Tbl_0, <PF1Tbl_1
;PF0PtrTbl:
;    .byte   <PF0Tbl_0, <PF0Tbl_1

PFMazeColTbl:
    .byte   $6a, $b8; $d4

VertMaskTbl:
    .byte   $80, $10
    .byte   $01, $08, $80, $08
    .byte   $01, $10, $80
HorzMaskTbl:
    .byte   $20, $02
;    .byte   $03, $20, $20, $03
    .byte   $04, $40, $40, $04
    .byte   $02, $20


BlockSizeTbl:
    .byte   H_VERT*0 + H_HORZ*0
    .byte   H_VERT*1 + H_HORZ*0

    .byte   H_VERT*1 + H_HORZ*1
    .byte   H_VERT*2 + H_HORZ*1
    .byte   H_VERT*2 + H_HORZ*2
    .byte   H_VERT*3 + H_HORZ*2

    .byte   H_VERT*3 + H_HORZ*3
    .byte   H_VERT*4 + H_HORZ*3
    .byte   H_VERT*4 + H_HORZ*4
    .byte   H_VERT*5 + H_HORZ*4

    .byte   H_VERT*5 + H_HORZ*5
    .byte   H_VERT*6 + H_HORZ*5
    .byte   H_VERT*6 + H_HORZ*6


;****** SCORES ******
DH = 5

DigitPtrTbl:
    .byte   <Zero+DH-1-DigitTbl, <One+DH-1-DigitTbl, <Two  +DH-1-DigitTbl, <Three+DH-1-DigitTbl, <Four+DH-1-DigitTbl
    .byte   <Five+DH-1-DigitTbl, <Six+DH-1-DigitTbl, <Seven+DH-1-DigitTbl, <Eight+DH-1-DigitTbl, <Nine+DH-1-DigitTbl

DigitTbl:
Seven:
    .byte   %00100010
    .byte   %00100010
Four:
    .byte   %00100010
    .byte   %00100010
Zero:
    .byte   %11101110
    .byte   %10101010
    .byte   %10101010
    .byte   %10101010
Nine:
    .byte   %11101110
    .byte   %00100010
Eight:
    .byte   %11101110
    .byte   %10101010
Six:
    .byte   %11101110
    .byte   %10101010
    .byte   %11101110
    .byte   %10001000
Two:
    .byte   %11101110
    .byte   %10001000
Three:
    .byte   %11101110
    .byte   %00100010
Five:
    .byte   %11101110
    .byte   %00100010
    .byte   %11101110
    .byte   %10001000
One:
    .byte   %11101110
    .byte   %01000100
    .byte   %01000100
    .byte   %11001100
    .byte   %01000100

XGridTbl:
    .byte   X0,    X0+8,  X0+16,X0+24,X0+32, X0+40, X0+48, X0+55
    .byte   X0+62
    .byte   X0+69, X0+76, X0+84,X0+92,X0+100,X0+108,X0+116,X0+124
YGridTbl:
    .byte   Y0+H_GRID*0, Y0+H_GRID*1/2, Y0+H_GRID*1, Y0+H_GRID*3/2
    .byte   Y0+H_GRID*2, Y0+H_GRID*5/2, Y0+H_GRID*3, Y0+H_GRID*7/2
    .byte   Y0+H_GRID*4, Y0+H_GRID*9/2, Y0+H_GRID*5, Y0+H_GRID*11/2
    .byte   Y0+H_GRID*6


; helicopter graphics:
PlayerSizeTbl:
    .byte   %100000
    .byte   %000000
    .byte   %100000
    .byte   %110000
    .byte   %100000
    .byte   %000000
    .byte   %100000

PlayerMoveLeftA:
    .byte   $10
    .byte   $e0
    .byte   $00
    .byte   $10
    .byte   $20
    .byte   $d0
    .byte   $f0
PlayerMoveLeftB:
    .byte   $10
    .byte   $e0
    .byte   $00
    .byte   $10
    .byte   $20
    .byte   $00
    .byte   $c0

PlayerMoveRightA:
    .byte   $20
    .byte   $f0
    .byte   $c0
    .byte   $30
    .byte   $10
    .byte   $d0
    .byte   $e0
PlayerMoveRightB:
    .byte   $20
    .byte   $f0
    .byte   $c0
    .byte   $30
    .byte   $10
    .byte   $00
    .byte   $b0

    align 256

;initial values for the tanks:
TankColTbl
    .byte   $c8, $3c, $8c, $4a
TankXPos:
    .byte   X_TANK0, X_TANK1, X_TANK2, X_TANK3
TankYPos:
    .byte   Y_TANK0, Y_TANK1, Y_TANK2, Y_TANK3
TankDir:
    .byte   DIR_LEFT, DIR_LEFT, DIR_RIGHT, DIR_RIGHT

Mul14Tbl:
    .byte   H_TANK*2*0, H_TANK*2*1, H_TANK*2*2, H_TANK*2*3
    .byte   H_TANK*2*4, H_TANK*2*5, H_TANK*2*6, H_TANK*2*7, H_TANK*2*8
    .byte   H_TANK*2*9


UP_MASK    = %0001
RIGHT_MASK = %0010
DOWN_MASK  = %0100
LEFT_MASK  = %1000

  IF >CheckUp != >CheckLeft
    ECHO ""
    ECHO "ERROR: >CheckUp != >CheckLeft !"
    ECHO ""
    ERR
  ENDIF
CheckJSRTbl:
    .byte   <CheckUp, <CheckRight, <CheckDown, <CheckLeft
CheckDirTbl:
    .byte   DIR_DOWN, DIR_LEFT, DIR_UP, DIR_RIGHT

BitTbl:
    .byte   UP_MASK, RIGHT_MASK, DOWN_MASK, LEFT_MASK       ; 1, 2, 4, 8

TurnDirTbl:
    .byte   DIR_LEFT /4|DIR_UP   |DIR_DOWN *4|DIR_RIGHT*16  ; 9

    .byte   DIR_LEFT /4|DIR_UP   |DIR_DOWN *4|DIR_RIGHT*16  ;10
    .byte   DIR_UP   /4|DIR_LEFT |DIR_RIGHT*4|DIR_DOWN *16  ;11
    .byte   DIR_LEFT /4|DIR_DOWN |DIR_UP   *4|DIR_RIGHT*16  ; 8
    .byte   DIR_DOWN /4|DIR_LEFT |DIR_RIGHT*4|DIR_UP   *16  ; 7

    .byte   DIR_RIGHT/4|DIR_DOWN |DIR_UP   *4|DIR_LEFT *16  ; 3

    .byte   DIR_RIGHT/4|DIR_UP   |DIR_DOWN *4|DIR_LEFT *16  ; 2
    .byte   DIR_UP   /4|DIR_RIGHT|DIR_LEFT *4|DIR_DOWN *16  ; 1
    .byte   DIR_RIGHT/4|DIR_DOWN |DIR_UP   *4|DIR_LEFT *16  ; 4
    .byte   DIR_DOWN /4|DIR_RIGHT|DIR_LEFT *4|DIR_UP   *16  ; 5

    .byte   DIR_UP   /4|DIR_RIGHT|DIR_LEFT *4|DIR_DOWN *16  ; 0
    .byte   0                                               ; -
    .byte   DIR_DOWN /4|DIR_LEFT |DIR_RIGHT*4|DIR_UP   *16  ; 6


NewDirTbl:
    .byte   DIR_UP        , POS_TURN|%0001, -1            , NEG_TURN|%1111
    .byte   NEG_TURN|%0011, DIR_RIGHT     , POS_TURN|%0101, -1
    .byte   -1            , NEG_TURN|%0111, DIR_DOWN      , POS_TURN|%1001
    .byte   POS_TURN|%1101, -1            , NEG_TURN|%1011, DIR_LEFT


XDirTbl:
    .byte   0; 1, 0,-1
YDirTbl:
    .byte   1, 0,-1, 0

MislOfsX:
;    .byte   4, 8, 3,-8
    .byte   4, 8, 3,-4
MislOfsY:
;    .byte   6,-4,-8,-5
    .byte   4,-4,-8,-5
MislHeight
;    .byte   6, 1, 6, 1
    .byte   4, 1, 4, 1
MislSize:
;    .byte   %000000, %110000, %000000, %110000
    .byte   %000000, %100000, %000000, %100000


;boundaries for tank collisions:
XCheck1Tbl:
    .byte   H_TANK+1  , 10+1      , H_TANK+1  , 0+1
XCheck2Tbl:
    .byte   H_TANK*2+1, 10+1      , H_TANK*2+1, 10+1
YCheck1Tbl:
    .byte   10+1      , H_TANK+1  , 0+1       , H_TANK+1
YCheck2Tbl:
    .byte   10+1      , H_TANK*2+1, 10+1      , H_TANK*2+1

    org     $f770

;****** PLAYERS ******
TankPatTbl:
;    .byte   %00111000
;    .byte   %01000100
;    .byte   %10110010
;    .byte   %10111010
;    .byte   %10100010
;    .byte   %01000000
;    .byte   %00100000
Tank0a:
    .byte   %00000000
    .byte   %01000100
    .byte   %00101000   ; X X
    .byte   %10111010   ; XOX
    .byte   %00010000   ;  X
    .byte   %01000100
    .byte   %00010000   ;  X
Tank0b:
    .byte   %00000000
    .byte   %00000000
    .byte   %10101010
    .byte   %00111000
    .byte   %10010010
    .byte   %00000000
    .byte   %00111000
Tank23a:
    .byte   %00001000
    .byte   %00000000
    .byte   %10001010   ;   X
    .byte   %00111000   ; XXX
    .byte   %10011010   ;  XX
    .byte   %00000000
    .byte   %00101000   ;   X
Tank23b:
    .byte   %00000000
    .byte   %00000100
    .byte   %00001000
    .byte   %10111010
    .byte   %00011000
    .byte   %01000100
    .byte   %00011000
Tank45a:
    .byte   %00010000
    .byte   %00000100
    .byte   %00010000   ;  X
    .byte   %10111010   ; XXX
    .byte   %00011000   ;  XX
    .byte   %01000100   ;    X
    .byte   %00010000
Tank45b:
    .byte   %00001000
    .byte   %00000000
    .byte   %00010010
    .byte   %00111000
    .byte   %10011010
    .byte   %00000100
    .byte   %00101000
Tank78a:
    .byte   %00101000
    .byte   %00000000
    .byte   %00010010   ;  X
    .byte   %00011000   ;  XX
    .byte   %10111010   ; XXX X
    .byte   %00000000
    .byte   %00101000
Tank78b:
    .byte   %00010000
    .byte   %00000100
    .byte   %00010000
    .byte   %00011010
    .byte   %00111010
    .byte   %01000100
    .byte   %00010000
Tank90a
    .byte   %00010000
    .byte   %01000100
    .byte   %00110000   ; XX
    .byte   %00011010   ;  XX X
    .byte   %00110000   ; XX
    .byte   %01000100
    .byte   %00010000
Tank90b
    .byte   %00101000
    .byte   %00000000
    .byte   %00110010
    .byte   %00011010
    .byte   %00110010
    .byte   %00000000
    .byte   %00101000
Tank113a:
    .byte   %00101000
    .byte   %00000000
    .byte   %10111010   ; XXX X
    .byte   %00011000   ;  XX
    .byte   %00010010   ;  X
    .byte   %00000000
    .byte   %00101000
Tank113b:
    .byte   %00010000
    .byte   %01000100
    .byte   %00111010
    .byte   %00011010
    .byte   %00010000
    .byte   %00000100
    .byte   %00010000
Tank135a:
    .byte   %00010000
    .byte   %01000100   ;    X
    .byte   %00011000   ;  XX
    .byte   %10111010   ; XXX
    .byte   %00010000   ;  X
    .byte   %00000100
    .byte   %00010000
Tank135b:
    .byte   %00101000
    .byte   %00000100
    .byte   %10011010
    .byte   %00111000
    .byte   %00010010
    .byte   %00000000
    .byte   %00001000
Tank148a:
    .byte   %00101000   ;   X
    .byte   %00000000
    .byte   %10011010   ;  XX
    .byte   %00111000   ; XXX
    .byte   %10001010   ;   X
    .byte   %00000000
    .byte   %00001000
Tank148b:
    .byte   %00011000
    .byte   %01000100
    .byte   %00011000
    .byte   %10111010
    .byte   %00001000
    .byte   %00000100
    .byte   %00000000
Tank180a:
    .byte   %00010000   ;  X
    .byte   %01000100
    .byte   %00010000   ;  X
    .byte   %10111010   ; XOX
    .byte   %00101000   ; X X
    .byte   %01000100
    .byte   %00000000
Tank180b:
    .byte   %00111000
    .byte   %00000000
    .byte   %10010010
    .byte   %00111000
    .byte   %10101010
    .byte   %00000000
    .byte   %00000000

NoTankA:
    .byte   %00010000   ;   X
    .byte   %01000100   ; X   X
    .byte   %00000000   ;
    .byte   %10000010   ;X     X
    .byte   %00000000   ;
    .byte   %01000100   ; X   X
    .byte   %00010000   ;   X
NoTankB:
    .byte   %00101000   ;  X X
    .byte   %00000000   ;
    .byte   %10000010   ;X     X
    .byte   %00000000   ;
    .byte   %10000010   ;X     X
    .byte   %00000000   ;
    .byte   %00101000   ;  X X


    org $f7fc
    .word   Start
    .word   Start
